import { FieldConfigMetadata } from '@aws-amplify/codegen-ui';
import { AwaitExpression, CallExpression, ObjectLiteralElementLike, Statement } from 'typescript';
import { ImportCollection } from '../imports';
export declare enum ActionType {
    CREATE = "create",
    UPDATE = "update",
    DELETE = "delete",
    LIST = "list",
    GET = "get",
    GET_BY_RELATIONSHIP = "getByRelationship"
}
export declare const getGraphqlQueryForModel: (action: ActionType, model: string, byFieldName?: string) => string;
/**
 * Returns a GraphQL call expression and adds to importCollection.
 *
 * @example
 * ```
 * API.graphql({
 *  query: createTodo,
 *  variables: {
 *    input: {
 *      inputs
 *    },
 *  },
 * });
 * ```
 */
export declare const getGraphqlCallExpression: (action: ActionType, model: string, importCollection: ImportCollection, variables?: ObjectLiteralElementLike[] | {
    inputs?: ObjectLiteralElementLike[] | undefined;
    filters?: ObjectLiteralElementLike[] | undefined;
} | undefined, byFieldName?: string | undefined) => CallExpression;
export declare const getFetchRelatedRecords: (relatedModelName: string) => string;
export declare const getFetchRelatedRecordsCallbacks: (fieldConfigs: Record<string, FieldConfigMetadata>, importCollection: ImportCollection) => Statement[];
export declare function wrapInParenthesizedExpression(callExpression: CallExpression, accessors: string[]): AwaitExpression;
